import type { ComponentClass, FunctionComponent } from "react";
import type { Readable, Writable } from "svelte/store";
export declare type HandlerName<T extends string> = `on${Capitalize<T>}`;
export declare type EventName<T extends string> = T extends `on${infer N}` ? Uncapitalize<N> : never;
export declare type SvelteEventHandlers<T> = T extends Record<infer Key extends string, infer Value> ? Partial<Record<HandlerName<Key>, (e: Value) => void | boolean>> : never;
declare type Uppercase = "A" | "B" | "C" | "D" | "E" | "F" | "G" | "H" | "I" | "J" | "K" | "L" | "M" | "N" | "S" | "T" | "U" | "V" | "W" | "X" | "Y" | "Z";
declare type ReactEventProp = `on${Uppercase}${string}`;
declare type ExcludeProps<T> = T extends ReactEventProp ? T : never;
declare type ExcludeEvents<T> = T extends ReactEventProp ? never : T;
export declare type EventProps<ReactProps> = Omit<ReactProps, ExcludeEvents<keyof ReactProps>>;
export declare type OmitEventProps<ReactProps> = Omit<ReactProps, ExcludeProps<keyof ReactProps>>;
export declare type TreeNode = Omit<SvelteInit, "onDestroy"> & {
    svelteInstance: Readable<any>;
    reactComponent: FunctionComponent<any> | ComponentClass<any>;
    key: number;
    hooks: Writable<Array<{
        Hook: FunctionComponent;
        key: number;
    }>>;
    nodes: TreeNode[];
};
export declare type SvelteInit = {
    parent?: TreeNode;
    props: Readable<Record<string, any>>;
    target: Readable<HTMLElement | undefined>;
    slot: Readable<HTMLElement | undefined>;
    hooks: Writable<Array<{
        Hook: FunctionComponent;
        key: number;
    }>>;
    onDestroy: (callback: () => void) => void;
};
export {};
