import * as React from "react";
import type { SvelteEventHandlers } from "./internal/types";
export declare type SvelteConstructor<Props = any, Events = any, Slot = any> = {
    name: string;
    prototype: {
        $$prop_def: Props;
        $$events_def: Events;
        $$slot_def: Slot;
    };
};
/**
 * Convert a Svelte component into a React component.
 */
export default function reactify<P = any, E = any>(SvelteComponent: SvelteConstructor<P, E>): React.FunctionComponent<P & SvelteEventHandlers<E>>;
